# CustomCompoundBondForceImpl Class Reference

This is the internal implementation of CustomCompoundBondForce. More...

`#include <CustomCompoundBondForceImpl.h>`

Inheritance diagram for CustomCompoundBondForceImpl:

List of all members.

## Public Member Functions
| CustomCompoundBondForceImpl (const CustomCompoundBondForce &owner)
| ~CustomCompoundBondForceImpl ()
void | initialize (ContextImpl &context)
| This is called after the ForceImpl is created and before updateContextState(), calcForces(), or calcEnergy() is called on it.
const CustomCompoundBondForce & | getOwner () const
| Get the Force object from which this ForceImpl was created.
void | updateContextState (ContextImpl &context)
| This method is called at the beginning of each time step.
double | calcForcesAndEnergy (ContextImpl &context, bool includeForces, bool includeEnergy, int groups)
| Calculate the force on each particle generated by this ForceImpl and/or this ForceImpl's contribution to the potential energy of the system.
std::map< std::string, double > | getDefaultParameters ()
| Get a map containing the default values for all adjustable parameters defined by this ForceImpl.
std::vector< std::string > | getKernelNames ()
| Get the names of all Kernels used by this Force.
void | updateParametersInContext (ContextImpl &context)
## Static Public Member Functions
static Lepton::ParsedExpression | prepareExpression (const CustomCompoundBondForce &force, const std::map< std::string, Lepton::CustomFunction * > &functions, std::map< std::string, std::vector< int > > &distances, std::map< std::string, std::vector< int > > &angles, std::map< std::string, std::vector< int > > &dihedrals)
| This is a utility routine that parses the energy expression, identifies the angles and dihedrals in it, and replaces them with variables.

## Detailed Description

This is the internal implementation of CustomCompoundBondForce.

## Constructor & Destructor Documentation

CustomCompoundBondForceImpl | ( | const CustomCompoundBondForce & | owner | ) |

~CustomCompoundBondForceImpl | ( |  | ) |

## Member Function Documentation

double calcForcesAndEnergy | ( | ContextImpl & | context,
|  | bool | includeForces,
|  | bool | includeEnergy,
|  | int | groups |
| ) |  |  | `[virtual]`

Calculate the force on each particle generated by this ForceImpl and/or this ForceImpl's contribution to the potential energy of the system.

Parameters:

  | context | the context in which the system is being simulated
  | includeForces | true if forces should be calculated
  | includeEnergy | true if the energy should be calculated
  | groups | a set of bit flags for which force groups to include. Group i should be included if (groups&(1<<i)) != 0.

Returns:
  this force's contribution to the potential energy of the system, or 0 if this force does not contribute to potential energy (or if includeEnergy is false)

Implements ForceImpl.

std::map<std::string, double> getDefaultParameters | ( |  | ) | `[virtual]`

Get a map containing the default values for all adjustable parameters defined by this ForceImpl.

These parameters and their default values will automatically be added to the Context.

Implements ForceImpl.

std::vector<std::string> getKernelNames | ( |  | ) | `[virtual]`

Get the names of all Kernels used by this Force.

Implements ForceImpl.

const CustomCompoundBondForce& getOwner | ( |  | ) | const`[inline, virtual]`

Get the Force object from which this ForceImpl was created.

Implements ForceImpl.

void initialize | ( | ContextImpl & | context | ) | `[virtual]`

This is called after the ForceImpl is created and before updateContextState(), calcForces(), or calcEnergy() is called on it.

This allows it to do any necessary initialization.

Implements ForceImpl.

static Lepton::ParsedExpression prepareExpression | ( | const CustomCompoundBondForce & | force,
|  | const std::map< std::string, Lepton::CustomFunction * > & | functions,
|  | std::map< std::string, std::vector< int > > & | distances,
|  | std::map< std::string, std::vector< int > > & | angles,
|  | std::map< std::string, std::vector< int > > & | dihedrals |
| ) |  |  | `[static]`

This is a utility routine that parses the energy expression, identifies the angles and dihedrals in it, and replaces them with variables.

Parameters:

  | force | the CustomCompoundBondForce to process
  | functions | definitions of custom function that may appear in the expression
  | distances | on exit, this will contain an entry for each distance used in the expression. The key is the name of the corresponding variable, and the value is the list of particle indices.
  | angles | on exit, this will contain an entry for each angle used in the expression. The key is the name of the corresponding variable, and the value is the list of particle indices.
  | dihedrals | on exit, this will contain an entry for each dihedral used in the expression. The key is the name of the corresponding variable, and the value is the list of particle indices.

Returns:
  a Parsed expression for the energy

void updateContextState | ( | ContextImpl & | context | ) | `[inline, virtual]`

This method is called at the beginning of each time step.

It give the ForceImpl a chance to modify the state variables (positions, velocities, and parameters) stored in the Context in arbitrary ways before integration is performed.

Parameters:

  | context | the context in which the system is being simulated

Implements ForceImpl.

void updateParametersInContext | ( | ContextImpl & | context | ) |

The documentation for this class was generated from the following file:

- CustomCompoundBondForceImpl.h